<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_base_component_template".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryBaseComponentTemplate".
 *
 * Columns in table "directory_base_component_template" available as properties of the model,
 * followed by relations of table "directory_base_component_template" available as properties of the model.
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 * @property string $config
 * @property integer $enabled
 * @property integer $type_id
 *
 * @property DirectoryBaseComponentType $type
 */
abstract class BaseDirectoryBaseComponentTemplate extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_base_component_template';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryBaseComponentTemplate|DirectoryBaseComponentTemplates', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('name, config, type_id', 'required'),
            array('enabled, type_id', 'numerical', 'integerOnly'=>true),
            array('name', 'length', 'max'=>50),
            array('description', 'length', 'max'=>200),
            array('description, enabled', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, name, description, config, enabled, type_id', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'type' => array(self::BELONGS_TO, 'DirectoryBaseComponentType', 'type_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'name' => Yii::t('app', 'Name'),
            'description' => Yii::t('app', 'Description'),
            'config' => Yii::t('app', 'Config'),
            'enabled' => Yii::t('app', 'Enabled'),
            'type_id' => null,
            'type' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('name', $this->name, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('config', $this->config, true);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('type_id', $this->type_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
